//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   PickList from Doubly-Linked List


#include"gd_tools.h"
#include"gd_extrn.h"
#include"gd_kb.h"
#include"gd_llist.h"


#define DEBUGMODE FALSE


picklist_t pl ;


static  void    dllpl_hilite(int which,BOOL turn_on,STRING s);
static  void    dllpl_arrows(void);


void    dll_picklist_init( RC mnuwid, RC lines_on_scr, STRING title )
{
    register int x ;

    CLR_BLOCK(pl);                              // clear structure
    pl.maxlines = lines_on_scr ;
    if ( vid.is_color )
    {
        pl.fg  = BLUE ;
        pl.bg  = WHITE ;
        pl.bfg = RED ;
        pl.bbg = WHITE ;
        pl.hfg = YELLOW ;
        pl.hbg = RED ;
    }
    else
    {
        pl.fg = pl.bfg = pl.hbg = WHITE ;
        pl.bg = pl.bbg = pl.hfg = BLACK ;
    }

    if ( mnuwid < (int)strlen(title)+4 )
        mnuwid = strlen(title)+4 ;
    pl.title = title ;
    pl.line_width = mnuwid ;

    if ( llEntries > pl.maxlines )
    {
        pl.all_data_on_screen = FALSE ;
        pl.lines_on_screen = pl.maxlines ;
        pl.trow = 5 ;
    }
    else
    {
        pl.all_data_on_screen = TRUE ;
        pl.lines_on_screen = llEntries ;
        pl.trow = 5 + ((pl.maxlines-pl.lines_on_screen) / 2); // figure box placement
    }
    pl.brow = pl.trow+pl.lines_on_screen-1 ;
    if ( pl.line_width < 31 )
    {
        pl.lcol = 45 ;
        pl.rcol = pl.lcol+pl.line_width-1 ;
    }
    else
    {
        pl.rcol = 78 ;
        pl.lcol = pl.rcol-pl.line_width-1 ;
    }
    pl.btrow = pl.trow - 1 ;                    // box coordinates
    pl.bbrow = pl.brow + 1 ;
    pl.blcol = pl.lcol - 1 ;
    pl.brcol = pl.rcol + 1 ;

    pl.ss = SaveScreen( pl.ss );
    CursOff();

    box( pl.bfg, pl.bbg, pl.btrow, pl.blcol, pl.bbrow, pl.brcol, YES, 2 );
    DspMsg( pl.btrow, (RC)(pl.blcol+2), pl.bfg, pl.bbg, pl.title, NO );

    pl.llTOB = llFirst ;             // init TOB and CUR
    pl.llCUR = llFirst ;             // init TOB and CUR
    LOOP( x, 1, pl.lines_on_screen, 1 )
    {
        DspMsg( (RC)(pl.trow+x-1), pl.lcol, pl.fg, pl.bg, pl.llCUR->s, NO );
        pl.llBOB = pl.llCUR ;                   // bottom of box
        if ( pl.llCUR->next )
            pl.llCUR = pl.llCUR->next ;         // next current pointer
    }
    pl.llCUR = llFirst ;
    pl.curln = 1 ;
    dllpl_hilite( pl.curln, ON, pl.llCUR->s );
    dllpl_arrows();
// ErrMsg( "init: %s %s", pl.llCUR->s, pl.llBOB->s );
}


static  void    dllpl_arrows( void )
{
    if ( pl.all_data_on_screen )                // nothing to do
        return ;

    if ( pl.llTOB == llFirst )                  // first entry already displayed
        DspMsg( pl.btrow, (RC)(pl.brcol-1), pl.bfg, pl.bbg, "", NO );
    else                                        // can PgUp
        DspMsg( pl.btrow, (RC)(pl.brcol-1), pl.bfg, pl.bbg, "", NO );

    if ( pl.llBOB == llLast )                   // last entry already displayed
        DspMsg( pl.bbrow, (RC)(pl.brcol-1), pl.bfg, pl.bbg, "", NO );
    else                                        // can PgUp
        DspMsg( pl.bbrow, (RC)(pl.brcol-1), pl.bfg, pl.bbg, "", NO );
}


static  void    dllpl_hilite( int which, BOOL turn_on, STRING s )
{
    static COL fg, bg ;

    if ( turn_on )
    {   fg = pl.hfg;  bg = pl.hbg;  }
    else
    {   fg = pl.fg;   bg = pl.bg;   }
    DspMessage( (RC)(pl.trow-1+which), pl.lcol, fg, bg, "%-*s", pl.line_width, s );
}


static  void    dllpl_show_page( void )
{
    register int x ;
    BOOL        showing = TRUE ;

    llCurrent = pl.llTOB ;
    LOOP( x, 1, pl.lines_on_screen, 1 )
    {
        if ( showing )
            DspMessage( (RC)(pl.btrow+x), pl.lcol, pl.fg, pl.bg, "%-*s", pl.line_width, llCurrent->s );
        else
            DspMessage( (RC)(pl.btrow+x), pl.lcol, pl.fg, pl.bg, "%-*s", pl.line_width, "" );
        if ( llCurrent == pl.llBOB )
            showing = FALSE ;
        llCurrent = llCurrent->next ;           // next current pointer
    }
}


static  void    dllpl_down( void )
{
    if ( ! pl.llCUR->next )
        return ;

    dllpl_hilite( pl.curln, OFF, pl.llCUR->s );

    if ( pl.curln == pl.lines_on_screen )
    {
        if ( pl.llCUR == llLast )
        {
            sn_beep();                          // already at end of list
        }
        else
        {
            pl.llTOB = pl.llTOB->next ;
            pl.llBOB = pl.llBOB->next ;
            pl.llCUR = pl.llCUR->next ;
            dllpl_show_page();
        }
    }
    else
    {
        pl.curln += 1 ;
        pl.llCUR = pl.llCUR->next ;
    }
    dllpl_hilite( pl.curln, ON, pl.llCUR->s );
}


static  void    dllpl_up( void )
{
    if ( ! pl.llCUR->prev )
        return ;

    dllpl_hilite( pl.curln, OFF, pl.llCUR->s );

    if ( pl.curln == 1 )
    {
        if ( pl.llCUR == llFirst )
        {
            sn_beep();                          // already at top of list
        }
        else
        {
            pl.llTOB = pl.llTOB->prev ;
            pl.llBOB = pl.llBOB->prev ;
            pl.llCUR = pl.llCUR->prev ;
            dllpl_show_page();
        }
    }
    else
    {
        pl.curln -= 1 ;
        pl.llCUR = pl.llCUR->prev ;
    }
    dllpl_hilite( pl.curln, ON, pl.llCUR->s );
}


static  void    dllpl_page_down( void )
{
    register int x ;

    if ( pl.all_data_on_screen )                // nothing to do
        return ;

    LOOP( x, 1, (pl.lines_on_screen-1), 1 )
    {
        dllpl_down();
    }
}


static  void    dllpl_page_up( void )
{
    register int x ;

    if ( pl.all_data_on_screen )                // nothing to do
        return ;

    LOOP( x, 1, (pl.lines_on_screen-1), 1 )
    {
        dllpl_up();
    }
}


static  void    dllpl_home( void )
{
    while ( pl.llCUR != pl.llTOB )
    {
        dllpl_up();
    }
}


static  void    dllpl_end( void )
{
    while ( pl.llCUR != pl.llBOB )
    {
        dllpl_down();

// ErrMsg( "end: %s %s", pl.llCUR->s, pl.llBOB->s );

    }
}


static  void    dllpl_top_of_list( void )
{
    register int x ;

    if ( pl.all_data_on_screen )                // just go to bottom of screen
    {
        dllpl_home();
        return ;
    }
    pl.llTOB = pl.llBOB = llFirst ;
    LOOP( x, 2, pl.lines_on_screen, 1 )
    {
        pl.llBOB = pl.llBOB->next ;
    }
    pl.llCUR = llFirst ;
    pl.curln = 1 ;
    dllpl_show_page();
    dllpl_hilite( pl.curln, ON, pl.llCUR->s );
}


static  void    dllpl_end_of_list( void )
{
    register int x ;

    if ( pl.all_data_on_screen )                // just go to bottom of screen
    {
        dllpl_end();
        return ;
    }
    pl.llTOB = pl.llBOB = llLast ;
    LOOP( x, 2, pl.lines_on_screen, 1 )
    {
        pl.llTOB = pl.llTOB->prev ;
    }
    pl.llCUR = llLast ;
    pl.curln = pl.lines_on_screen ;
    dllpl_show_page();
    dllpl_hilite( pl.curln, ON, pl.llCUR->s );
}


void    debug_display( void )
{
#if DEBUGMODE
    UCHAR       *s = NULPTR ;
    STRING      pfmt = "%7s: [%s] pr=%s nx=%s  n=%d\n\t\t\t\t\t\ts=%s\n\n" ;
    UCHAR       a1[10], a2[10], a3[10] ;

    s = SaveScreen( s );
    cls();
    printf( "DEBUG DISPLAY ONLY!\n\n"
            "llEntries = %-7d all_data_on_screen = %-7d line_width = %d\n"
            " maxlines = %-7d    lines_on_screen = %-7d      curln = %d\n\n\n\n",
            llEntries, pl.all_data_on_screen, pl.line_width,
            pl.maxlines, pl.lines_on_screen, pl.curln );
    printf( pfmt, "llFirst", fmt_adr(llFirst, a1), fmt_adr(llFirst->prev, a2),
                  fmt_adr(llFirst->next, a3), llFirst->n, llFirst->s );
    printf( pfmt, "llLast", fmt_adr(llLast, a1), fmt_adr(llLast->prev, a2),
                  fmt_adr(llLast->next, a3), llLast->n, llLast->s );
    printf( pfmt, "pl.llTOB", fmt_adr(pl.llTOB, a1), fmt_adr(pl.llTOB->prev, a2),
                  fmt_adr(pl.llTOB->next, a3), pl.llTOB->n, pl.llTOB->s );
    printf( pfmt, "pl.llBOB", fmt_adr(pl.llBOB, a1), fmt_adr(pl.llBOB->prev, a2),
                  fmt_adr(pl.llBOB->next, a3), pl.llBOB->n, pl.llBOB->s );
    printf( pfmt, "pl.llCUR", fmt_adr(pl.llCUR, a1), fmt_adr(pl.llCUR->prev, a2),
                  fmt_adr(pl.llCUR->next, a3), pl.llCUR->n, pl.llCUR->s );
    sn_beep();
    kb_getkey_();
    s = RestoreScreen( s );
#else
    sn_beep();
#endif
}


STRING  dll_picklist( RC mnuwid, RC lines_on_scr, STRING title, char *pickerhelp[] )
{
    STRING      my_choice = "" ;
    BOOL        done=FALSE ;
    KB          ch ;

    dll_picklist_init( mnuwid, lines_on_scr, title );

    do  {
        ch = kb_getkey_();                      // get a keystroke
        switch ( ch )
        {
            case 0 :                            // nothing
                break ;
            case REG_F1 :                       // help
            case '?' :
            case '/' :
                sc_help_screen( pickerhelp );
                break ;
            case ESCAPE :                       // cancel
                done = TRUE ;
                my_choice = "" ;
                break ;
            case RETURN :                       // select
            case REG_F2 :
                done = TRUE ;
                my_choice = pl.llCUR->s ;
                break ;
            case C_DOWN :
            case C_RIGHT :
                dllpl_down();
                break ;
            case C_UP :
            case C_LEFT :
                dllpl_up();
                break ;
            case PGUP :
                dllpl_page_up();
                break ;
            case PGDN :
                dllpl_page_down();
                break ;
            case HOME :
                dllpl_home();
                break ;
            case END :
                dllpl_end();
                break ;
            case CTRL_HOME :
                dllpl_top_of_list();
                break ;
            case CTRL_END :
                dllpl_end_of_list();
                break ;
            case REG_F10 :                      // debug
                debug_display();
                break ;
            default :
                if ( isalnum(ch) )              // find matching entry, but don't quit
                {
    //  TODO yet!  <------------------------ //~~~
                }
                else
                    sn_beep();
        }
        dllpl_arrows();
    }   while ( ! done );

    pl.ss = RestoreScreen( pl.ss );
    return( my_choice );
}
