//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Doubly Linked Lists - Sort the List

#include"gd_tools.h"
#include"gd_llist.h"


int     dll_create_sorted( STRING data )
{
    static int datalen ;
    static dllist_t *new, *p, *old ;

//                                              prepare new entry first
    datalen = strlen(data);
    new = (dllist_t *) malloc( sizeof(dllist_t) );
    if ( new == (dllist_t *) NULPTR )
        return( GD_ERROR_NO_MEMORY );           // out of memory
    new->s = (STRING) malloc( datalen+1 );      // alloc memory for string
    if ( new->s == (STRING) NULPTR )
        return( GD_ERROR_NO_MEMORY );           // out of memory
    strcpy( new->s, data );                     // copy the string
    llSeqNum += 1 ;                             // increment sequence number
    new->n = llSeqNum ;                         // insert sequence number

//                                              we're ready to insert in list
    if ( llFirst == (dllist_t *) NULPTR )       // first entry
    {
        llFirst = llLast = new ;                // first = last entry
        new->prev = new->next = (dllist_t *) NULPTR ;
        llEntries = 1 ;
        llSeqNum  = 1 ;                         // sequence number in list
        return( GD_ERROR_NONE );
    }
    p   = llFirst ;                             // start at the top
    old = (dllist_t *) NULPTR ;
    while ( p )                                 // cruise the list
    {
        if ( _strnicmp(p->s, data, datalen) < 0 )
        {
            old = p ;                           // old entry is smaller
            p = p->next ;                       // skip to next
        }
        else                                    // new entry is smaller
        {
            if ( p->prev )                      // insert before current
            {
                p->prev->next = new ;
                new->next = p ;
                new->prev = p->prev ;
                p->prev = new ;
                llEntries += 1 ;
                return( GD_ERROR_NONE );
            }
            new->next = p ;                     // replace first element
            new->prev = (dllist_t *) NULPTR ;
            p->prev = new ;
            llEntries += 1 ;
            llFirst = new ;                // first entry pointer
            return( GD_ERROR_NONE );
        }
    }
    old->next = new ;                           // put at the end
    new->next = (dllist_t *) NULPTR ;
    new->prev = old ;
    llLast = new ;
    llEntries += 1 ;
    return( GD_ERROR_NONE );
}


#if 0
STRING  tst[] = { "Pan Lung", "Shadow Dragon", "Shen Lung", "T'ien Lung",
                  "Cloud Dragon", "Li Lung", "Lung Wang", "Mist Dragon",
                  "Yu Lung", "Faerie Dragon", "" };
void    main( void )
{
    int x=0 ;
    dll_init_list();
    while ( strlen(tst[x]) )
    {
        if ( dll_create_sorted( tst[x] ) != GD_ERROR_NONE )
        {   printf( "Error creating list entry for %s\n", tst[x] );  exit( 1 );  }
        x += 1 ;
    }
    printf( "\nDLL contents [sorted]:\n" );     dll_print_list();
}
#endif
