//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Calculate a Number for a Date

//<y>   Y2K compliance depends on other functions


#include"gd_tools.h"
#include"gd_y2k.h"

#pragma check_stack(off)


INT32   Date2Num( INT32 ymd )
/*
        Calculate a number for the given date.  This number represents the
        number of days elapsed since 31-Dec-1799, where 01-Jan-1800 = 1.
*/
{
    INT32       result=0;
    INT16       i, y, m, d, ref_year=1800;

    if ( DateSplit( ymd, &y, &m, &d ) == ERROR )
        return( ERROR );                        // illegal date
    if ( y < ref_year )
        return( ERROR );                        // less than reference year
    d = JulianDay( ymd );
    result = d;                                 // make long
    if ( y > ref_year )
    {
        for ( i=ref_year ; i < y ; i++ )
        {
            result = result + 365L;
            if ( (IsLeapYear( i )) )
                result = result + 1L;
        }
    }
    return( result );
}
