//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Convert dd-mmm-yy or ddmmmyy to yyyymmdd

//<y>   Y2K compliant. When a 2-digit year is given,
//      the century of today's date is used.


#include"gd_tools.h"
#include"gd_scrn.h"
#include"gd_y2k.h"


INT32   DateStr2ymd( UCHAR sdate[], INT16 dtyp )
{
    UCHAR       work[5] ;
    INT32       ymd ;
    INT16       yy, mm, dd, pos_d = 0, pos_m = 2, pos_y = 5 ;

    switch ( dtyp )
    {
        case DSTYP_DAT_DMY1 :                   // ddmmmyy
            pos_d = 0, pos_m = 2, pos_y = 5 ;
            break ;
        case DSTYP_DAT_DMY2 :                   // dd-mmm-yy
        case DSTYP_DAT_DMY3 :                   // dd-mmm-yyyy
            pos_d = 0, pos_m = 3, pos_y = 7 ;
            break ;
        default :
            return( (INT32) ERROR );
    }
    SubStr( work, sdate, pos_m, 3 );            // extract month part
    mm = Month2Number( work );
    if ( mm == ERROR )                          // invalid month
        return( (INT32) ERROR );
    SubStr( work, sdate, pos_d, 2 );            // extract day part
    dd = Str2Int( work );
    SubStr( work, sdate, pos_y, 4 );            // extract year part (2/4)
    yy = Str2Int( work );
    if ( yy < 100 )
        yy += dt_todays_century4();             // use century of today's date
    ymd = (yy * 10000L) + (mm * 100L) + dd;
    if ( ValidDate(ymd) == OK )
        return( ymd );
    return( (INT32) ERROR );
}


#if 0
void main(void)
{
    static  UCHAR   *tes[] = { "26-dec-2086", "31Sep84", "15-nov-49", "19SEP77", "12fEb76", "32-dec-87", "" };
    INT32   ymd ;
    INT16   dtype, i = 0 ;

    while ( strlen( tes[i] ) )
    {
        if ( strlen(tes[i]) == 7 )
            dtype = DSTYP_DAT_DMY1 ;
        else
            dtype = DSTYP_DAT_DMY2 ;
        ymd = DateStr2ymd( tes[i], dtype );
        printf( "Code %d   Date %-11s = %8ld\n", dtype, tes[i], ymd );
        i += 1 ;
    }
}
#endif
