//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Find the date for Easter

//<y>   Y2K compliance ... not tested   //~~~


#include "gd_tools.h"
#include"gd_y2k.h"


int     dt_easter( int year )
{
    int cen, leap, days, temp1, temp2;

    cen = year % 19;
    leap = year % 4;
    days = year % 7;
    temp1 = (19 * cen + 24) % 30;
    temp2 = (2 * leap + 4 * days + 6 * temp1 + 5) % 7;
    return (22 + temp1 + temp2);
}


#if 0
static  void easter( int yr )
{
    int day, mth=3 ;
    day = dt_easter( yr );
    if ( day > 31 )
    {
        day -= 31 ;
        mth = 4;
    }
    printf( "Easter is on %02d-%02d-%04d\n", day, mth, yr );
}
void    main( int argc, char *argv[] )
{
    int y ;
    LOOP( y, 1985, 2005, 1 ) { easter( y ); }
}
#endif
#if DOC
        This function returns the date for Easter.  If the return value is
        greater than 31 (the number of days in March), the return value minus
        31 is the date in April.  Otherwise, the return value is the March
        date.

        Argument list:  int year        the year desired (such as 1995)

        Return value:   int             the date for Easter (see note above)
#endif
