//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Find out how long a date field will be from FormatDate().
//      Useful when allocating space on the fly.

//<y>   Y2K compliant


#include"gd_tools.h"
#include"gd_y2k.h"


INT16   dt_format_size( INT16 outfmt )
{
    //  this table indicates the MAXIMUM length of dates formatted by FormatDate(),
    //  e.g., format code 0 returns a 7-char field, code 1 a 9-char field, etc.
    static int siz[] = { 7, 9, 11, 17, 18, 9, 14, 8, 3, 11, 12, 8, 8 };

    if ( OUTRANGE(outfmt,0,12) )
        return( ERROR );                        // illegal format code
    return( siz[outfmt] );
}
