//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Calculate the proper date from a Julian date

//<y>   Y2K compliance ... not tested   //~~~


#include"gd_tools.h"
#include"gd_y2k.h"

#pragma check_stack(off)


INT32   Jul2Date( INT32 num )
{
    INT32       y, m, done, days ;

    y   = num  /  1000;
    num = num MOD 1000;
    if ( y < 100 )
        y = y + 1900;                           // Y2K
    if ( OUTRANGE(num,1,366) )
        return( ERROR );                        // invalid date number
    if ( OUTRANGE(y,1800,2107) )                // Y2K ?
        return( ERROR );                        // invalid year

    for ( m=1, done=FALSE ; (num > 0L) && (m < 13L) && (!done) ; )
    {
        days = DaysInMonth( y*10000L + m*100L + 01L );
        if ( days > num )
        {
            done = TRUE;
        }
        else
        {
            m += 1;
            num = num - days;
        }
    }
    if ( num == 0L )
        return( (INT32) (y*10000L + (m-1)*100L + days) );
    else
        return( (INT32) (y*10000L + m*100L + num) );
}
