//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Calculate a Date from a Given Number

//<y>   Y2K compliance depends on other functions


#include"gd_tools.h"
#include"gd_y2k.h"

#pragma check_stack(off)


INT32   Num2Date( INT32 num )
/*
        The input number represents the number of days elapsed
        since 31-Dec-1799, where 01-Jan-1800 = 1.
*/
{
    INT32   ltmp, y=1799, m=0, d=0, done, days ;

    if ( OUTRANGE(num,1L,146097L) )
        return( ERROR );                        // invalid date number
    ltmp = num;
    if ( num > 36524L )
        {  ltmp = num - 36524L;  y = 1899;  }
    if ( num > 65743L )
        {  ltmp = num - 65743L;  y = 1979;  }
    if ( num > 73048L )
        {  ltmp = num - 73048L;  y = 1999;  }
#if 0
//                                              don't worry about this one yet!
    if ( num > 109573L )
        {  ltmp = num - 109573L;  y = 2099; }
#endif
    num = ltmp;

    for ( done=FALSE ; (num > 0L) && (!done) ; )
    {
        if ( (IsLeapYear( (INT16) y+1)) )       // No. of days in next year
            days = 366;
        else
            days = 365;
        if ( days > num )
            done = TRUE;
        else
        {
            y += 1;
            num = num - days;
        }
    }
    if ( num == 0L )
        return( (y*10000L + 1231L) );
    else
        return( Jul2Date( ((y+1)*1000L + num) ) );
}
