//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Split yyyymmdd date into yyyy, mm, and dd

//<y>   Year-sensitive routine
//<y>   Y2K compliance - if no century is given, the century of today's date
//      is assumed


#include"gd_tools.h"
#include"gd_y2k.h"

#pragma check_stack(off)


INT16   DateSplit( INT32 indate, INT16 *yyyy, INT16 *mm, INT16 *dd )
/*
        Split indate into separate fields: yyyy, mm, and dd.
        On error, 1980,01,01 is returned.

        Usage:      err = DateSplit( indate, &yyyy, &mm, &dd );

                    INT16   err     OK or ERROR
                    INT32   indate  date to be converted
                    INT16   *yyyy   the year, century default = today's century ... Y2K
                    INT16   *mm     the month
                    INT16   *dd     the day
*/
{
    INT32       century ;

    century = indate / 1000000 ;
    if ( century < 1 )
        indate = indate + ((INT32) dt_todays_century2() * 1000000L) ;   // Y2K

    *dd     = (INT16) (indate MOD 100L) ;
    indate /= 100L ;
    *mm     = (INT16) (indate MOD 100L) ;
    *yyyy   = (INT16) (indate / 100L) ;
    if ( INRANGE(*yyyy,1800,2107) && INRANGE(*mm,1,12) && INRANGE(*dd,1,31) )  // Y2K
        return( OK );
    *yyyy = Y2K_DOS_FST_LOW ;                   // Y2K
    *mm = *dd = 1 ;
    return( ERROR );                            // illegal date
}
