//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Get the System Date

//<y>   Y2K compliance depends on system clock


#include "gd_tools.h"
#include"gd_y2k.h"

#pragma check_stack(off)
#pragma optimize   ("",off)


INT16   dt_getsystemdate( INT32 *yyyymmdd, INT16 *yyyy, INT16 *mm, INT16 *dd )
/*
        Usage:  errcode = dt_getsystemdate(&ymd,&y,&m,&d);
*/
{
    int md, ye ;

    _asm
    {
        mov     ah, 2Ah
        int     21h
        mov     md, dx
        mov     ye, cx
    }

    *yyyy = ye ;
    *mm   = md >> 8 ;
    *dd   = md & 0xFF ;
    if ( OUTRANGE(*yyyy,Y2K_DOS_FST_LOW,Y2K_DOS_FST_HI) ||
         OUTRANGE(*mm,1,12) || OUTRANGE(*dd,1,31) )  // Y2K
    {
        *mm = *dd = 1;
        *yyyy  = Y2K_DOS_FST_LOW ;              // Y2K
        *yyyymmdd = (Y2K_DOS_FST_LOW*10000L) + 101L ; // Y2K
        return( ERROR );                        // illegal system date
    }
    *yyyymmdd = ((*yyyy)*10000L) + ((*mm)*100L) + (*dd);
    return( OK );
}


#if 0
void main(void)
{
    INT32 ymd ;
    INT16 err, y, m, d ;

    err = dt_getsystemdate(&ymd,&y,&m,&d);
    printf( "%ld -> %d %d %d\n", ymd,y,m,d);
}
#endif
