//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Calculate the Week Number, Counting from the First Sunday of the Year
//      Cool for payroll stuff...

//<y>   Y2K compliance depends on other functions


#include"gd_tools.h"
#include"gd_y2k.h"


int     dt_weeknumber( INT32 ymd )
{
    INT16       y, m, d, dow ;
    INT32       Jan1, Sun, Sat, days ;
    int         weeknumber = 0 ;

    if ( DateSplit( ymd, &y, &m, &d ) == ERROR )
        return( -1 );                           // illegal date
    Jan1 = (INT32)y*10000L + 101L ;
    dow = WhatWeek( Jan1, &Sun, &Sat );
    if ( dow != 1 )                             // not Sunday
        Sun = NewDate( Sat, 1, 1 );             // first Sunday of the year
    if ( ymd < Sun )                            // given date < 1st Sunday
        return( 0 );                            // week zero
    days = DaysBetween( ymd, Sun );
    weeknumber = ((int)days / 7) + 1 ;
    dow = WhatWeek( ymd, &Sun, &Sat );
    return( weeknumber );
}


#if 0
void    main( void )
{
    INT32       ymd=19941201L, Sun, Sat ;
    int         x, w, dow ;
    LOOP( x, 1, 500, 1 )
    {
        w = dt_weeknumber( ymd );
        dow = WhatWeek( ymd, &Sun, &Sat );
        printf( "date = %08ld  week = %02d %d\n", ymd, w, dow );
        ymd = NewDate( ymd, 1, 1 );
    }
}
#endif
