//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Create/Replace a File

#include"gd_tools.h"


FILE *  fl_create_or_replace_tty( FILE *fHandle, const STRING fName, const STRING fOpenMode, const BOOL abort_on_error, BOOL verbose )
{
    int ch ;

    if ( fl_exist( fName ) )
    {
        fprintf( stderr, "\nOutput file %s already exists. Replace?    \b\b\b", fName );
        do  {
            ch = _getch();
            ch = toupper(ch);
        }   while ( ch != 'N' && ch != 'Y' );
        if ( ch == 'N' )
        {
            fprintf( stderr, "Cancelled\n" );
            if ( abort_on_error )
                exit( GD_ERROR_FILE_ALREADY_EXISTS );
            return( (FILE *) NULPTR );
        }
        fprintf( stderr, "\r%78s\r", "" );
        if ( verbose )
            fprintf( stderr, "Replacing file %s", fName );
    }
    else
    {
        if ( verbose )
            fprintf( stderr, "\n\r%78s\rCreating file %s", "", fName );
    }

    fHandle = fopen( fName, fOpenMode );
    if ( fHandle == NULL )
    {
        fprintf( stderr, " ... Error [%d] opening in \"%s\" mode!\a\n", (int)GD_ERROR_CANNOT_OPEN_FOR_WRITE, fOpenMode );
        if ( abort_on_error )
            exit( GD_ERROR_CANNOT_OPEN_FOR_WRITE );
        return( (FILE *) NULPTR );
    }
    if ( verbose )
        fprintf( stderr, "\n\n" );
    return( fHandle );
}
