//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Read .INI file and Extract Field Data

#include"gd_tools.h"

//      Syntax:
//
//      len = fl_parse_ini( "win.ini", "intl", "sShortDate", data, &iRecNumber );
//
//      len is ERROR if there is something wrong
//             0 if found, but no data to the right of the "="
//             length of the returned string, e.g. 10 if "dd-MM-yyyy" was found


int     fl_parse_ini( STRING sFile, STRING sHeader, STRING sField,
                      STRING sContent, int *iRecNo )
{
    FILE        *ini ;
    UCHAR       rec[256], *eq ;
    BOOL        looking4header = TRUE ;
    int         recct = 0 ;

    *sContent = EOS ;                           // initialize
    *iRecNo = 0 ;
    ini = fopen( sFile, "r" );
    if ( ! ini )
        return( ERROR );                        // can't open file

    while ( fgets( rec, sizeof(rec), ini ) )
    {
        recct++ ;
        st_trim( rec );
        if ( looking4header )
        {
            if ( rec[0] == '[' )
            {
                rec[0] = SPACE ;                // remove [ and ]
                rec[strlen(rec)-1] = EOS ;
                st_trim( rec );                 // trim again
                if ( st_eq(rec, sHeader) )
                    looking4header = FALSE ;    // found the proper header
            }
        }
        else                                    // we're looking for the field
        {
            if ( rec[0] == '[' )                // next header, so we missed it
            {
                fclose( ini );
                return( ERROR );
            }
            //  see if we have the correct field
            eq = strchr( rec, '=' );
            if ( eq )
            {
                *eq = EOS ;
                st_trim( rec );                 // in case we have a space before the =
                if ( st_eq(rec, sField) )
                {
                    eq++ ;                      // point beyond '='
                    strcpy( sContent, eq );     // save the parameter
                    st_trim( sContent );        // remove leading & trailing spaces
                    fclose( ini );
                    *iRecNo = recct ;
                    return( strlen(sContent) ); // we're done
                }
            }
        }
    }
    fclose( ini );
    return( ERROR );                            // not found
}


#if 0
void    main( int argc, char *argv[] )
{
    int         len, r ;
    UCHAR       data[256] ;

    len = fl_parse_ini( "win.ini", "intl", "sShortDate", data, &r );
    printf( "\n  rc=%d\ndata=\"%s\"\nfound at line %d.\n", len, data, r );
}
#endif
