//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Rename a file

#include "gd_tools.h"
#include <io.h>


INT16   fl_rename( STRING old_file, STRING new_file )
/*
  Synopsis      ret_code = fl_rename( old_file, new_file )
                INT16 ret_code  DOS function error return code
                UCHAR *old_file Previous file name
                UCHAR *new_file New file name

  Description   This function changes the name of one file to another.  Path
                names may be used, but cannot contain wildcards (* or ?) or
                specify different devices/drives.  By using pathnames, files can
                be effectively moved from one directory to another.

  Returns       ret_code        DOS error code, or OK
*/
{
    if ( rename( old_file, new_file ) != 0 )
        return( errno );
    else
        return( OK );
}
