//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   NetWare: Get server information


#include"gd_tools.h"
#include"gd_nw.h"
#include"nit.h"


BOOL    nw_fileServerData( STRING osVersion, STRING osRevision,
                           STRING osCopyright, STRING osSerialNumber,
                           STRING osAppNumber, int *maxUsers )
{
    int         verify, appnum ;
    long        sernum ;
    UCHAR       wComp[80], wRev[80], wRevDate[24], wCopr[80] ;

    *osVersion = *osRevision = *osCopyright = *osSerialNumber = *osAppNumber = EOS ;
    *maxUsers = 0 ;
    verify = GetFileServerDescriptionStrings( wComp, wRev, wRevDate, wCopr );
    if ( verify == 0 )
    {
        st_trim( wRev );
        sprintf( osVersion, "NetWare Version %s %s", wComp, wRev );
        sprintf( osRevision, "Revision %s", wRevDate );
        st_reduce_spaces( wCopr );
        strcpy( osCopyright, wCopr );
        ST_CPY( wCopr, &wRev[st_ch_index('(',wRev)+1] );
        wCopr[st_ch_index(' ',wCopr)] = EOS ;
        *maxUsers = atoi( wCopr );
    }

    verify = GetNetworkSerialNumber( &sernum, &appnum );
    if ( verify == 0 )
    {
        sprintf( osSerialNumber, "%08lX", sernum );
        sprintf( osAppNumber,    "%04X" , appnum );
    }
    if ( IsV3Supported(GetDefaultConnectionID()) )
        return( TRUE );
    return( FALSE );
}


#if 0
void main( void )
{
    BOOL        is386 ;
    UCHAR       vers[80], rev[80], copr[80], ser[80], app[80] ;
    int         users ;
    is386 = nw_fileServerData( vers, rev, copr, ser, app, &users );
    printf( "%s.\n%s.\n%s\nSerial %s App %s.\nNetware 386 is%s supported.\n"
            "Maximum %d users can be logged in at any one time.\n",
            vers, rev, copr, ser, app, (is386 ? "" : " not"), users );
}
#endif
