//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Show all mapped drives

#include"gd_tools.h"
#include"gd_nw.h"
#include"nit.h"


int     nw_drive_mapping( BYTE drv, STRING path )
{
    int         ccode ;
    BYTE        dirHandle, status ;
    WORD        connID, defConnID = (WORD) nw_get_default_connection_id();
    UCHAR       dirPath[256], serverName[48], origdir[256] ;
    unsigned    numofdrives ;

    *path = EOS ;                               // in case of error

    if ( ! ValidDrive( drv ) )
        return( -1 );                           // invalid drive

    status = GetDriveInformation( (BYTE) drv, &connID, &dirHandle );
    if ( status & DRIVE_LOCAL )
        return( -2 );                           // local drive

    _getcwd( origdir, sizeof(origdir) );        // get current directory and drive

    if ( connID != defConnID )                  // not on default server
        _dos_setdrive( drv+1, &numofdrives );
    ccode = GetDirectoryPath( dirHandle, dirPath );
    if ( connID != defConnID )                  // set back
        _dos_setdrive( origdir[0] - 64, &numofdrives );

    GetFileServerName( connID, serverName );    // server name prefix

    sprintf( path, "%s/%s", serverName, dirPath );

    return( 0 );                                // all's well!
}


#if 0
void    main( void )
{
    int         i, ccode ;
    UCHAR       dirPath[256] ;

    LOOP( i, 0, 25, 1 )
    {
        ccode = nw_drive_mapping( (BYTE) i, dirPath );
        if ( ccode )
            printf( "%c: = %d\n", ((UCHAR)'A'+(UCHAR)i), ccode );
        else
            printf( "%c: = %s\n", ((UCHAR)'A'+(UCHAR)i), dirPath );
    }
}
#endif
