//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Timed message to log file

#include"gd_tools.h"
#include"gd_extrn.h"
#include"gd_nw.h"


BOOL    nw_logmsg( STRING instuff )
{
    FILE        *out ;
    int         strikes = 0 ;
    INT16       i1, i2, i3, i4 ;
    INT32       ymd, hmst,tics ;
    UCHAR       stuff[128], outname[31], server_name[49], user_name[49], node_addr[13] ;
    STRING      logvolume ;

    ST_CPY ( stuff, instuff );
    st_trim( stuff );
    if ( ! strlen(stuff) )
        return( ERROR );

    //                                  default values
    logvolume = "C:\\" ;
    ST_CPY( server_name, "?" );
    ST_CPY( user_name  , "?" );
    ST_CPY( node_addr  , "000000000000" );

    //  dont't use nw_installed_NetWare() function
    nw_get_username( user_name );
    if ( st_len(user_name) )        // logged in
    {
        ST_CPY( server_name, nw_server_name( nw_get_default_connection_id() ) );
        nw_get_username( user_name );
        nw_get_station_address( node_addr );
        logvolume = "SYS:DATA\\" ;
    }
    else
    {
        ST_CPY( user_name, "?" );
    }
    ST_CPY( outname, logvolume );       // volume
    ST_CAT( outname, "logs" );          // directory name
    dr_mkdir( outname, NO );            // make, if req'd
    ST_CAT( outname, "\\logmsg.dat" );  // filename

strike:
    out = fopen( outname, "a+" );
    if ( ! out )
    {
        strikes += 1 ;
        if ( strikes < 99 )
            goto strike ;
        return( ERROR );
    }
    dt_getsystemdate( &ymd, &i1, &i2, &i3 );
    tm_getsystemtime( &hmst, &tics, &i1, &i2, &i3, &i4 );
    if ( st_len(user_name) )        // logged in
        fprintf( out, "%08ld %08ld %-12s %s %s: %s\n", ymd, hmst, node_addr, server_name, user_name, stuff );
    else
        fprintf( out, "%08ld %08ld: %s\n", ymd, hmst, stuff );
    fclose( out );
    return( OK );
}


#if 0
void    main( void )
{
    if ( nw_logmsg( "This is test 1" ) != OK )
        printf( "Test 1 failed\n" );
    if ( nw_logmsg( "This is test 2" ) != OK )
        printf( "Test 2 failed\n" );
    exit( 0 );
}
#endif
