//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Map (Delete) a Fake Root

#include"gd_tools.h"
#include"gd_nw.h"
#include"nit.h"


typedef struct  DE_PDH_REQUEST_
{
        WORD    buffer_length ;
        BYTE    function ;
        BYTE    dir_handle ;
}       de_pdh_req ;
typedef struct  DE_PDH_REPLY_
{
        WORD    buffer_length ;
}       de_pdh_rep ;


int     nw_deallo_dir_handle( BYTE dirHandle )
{
    de_pdh_req  req ;
    de_pdh_rep  rep ;

    //  setup the NetWare packets
    CLR_BLOCK(req);
    CLR_BLOCK(rep);
    NW_SET_BUFFER_SIZE(req);
    NW_SET_BUFFER_SIZE(rep);
    req.function   = (BYTE) 0x14 ;
    req.dir_handle = dirHandle ;
    return( nw_call_w_buffers(0xE2, &req, &rep) );
}


BYTE    nw_get_dir_handle( UCHAR drv )
{
    R_REGS ;

    _AX = 0xE900 ;
    _DX = (WORD) drv - 'A' ;
    INTDOS( r );
    return( _AL );
}


int     nw_map_fakeroot( UCHAR drv, STRING path_to_map )
{
    UCHAR far *p = path_to_map ;
    R_REGS ;
    S_SREGS ;

    _AX = 0xE905 ;
    _BL = drv - (UCHAR)'@' ;
    _DX = FP_OFF(p);
    _DS = FP_SEG(p);
    INTDOSX( r, s );
    if ( _CFLAG )
        return( _AL );
    return( 0 );
}


void    nw_del_drive_mapping( UCHAR drv )
{
    BYTE dirH ;

    dirH = nw_get_dir_handle( drv );
    if ( dirH )
        nw_deallo_dir_handle( dirH );
}


void    nw_del_fakeroot( UCHAR drv )
{
    R_REGS ;

    _AX = 0xE906 ;                              // delete fake root
    _BL = drv - (UCHAR)'@' ;                    // .. resets root to real root
    INTDOS( r );                                // .. keeps drive letter
}


#if 0
void    main( int argc, char *argv[] )
{
    UCHAR       drv, path[256] ;
    BOOL        do_map = FALSE ;
    int         ret ;

    printf( "\n" );
    if ( argc != 4 )
    {
        printf( "3 params: [map|del] driveletter [path|*]\n" );
        exit( 1 );
    }
    ST_CPY( path, argv[1] );
    strupr( path );
    if ( *path == 'M' )
        do_map = TRUE ;
    else
    if ( *path != 'D' )
    {
        printf( "first par must be MAP or DEL\n" );
        exit( 1 );
    }
    ST_CPY( path, argv[2] );
    strupr( path );
    drv = *path ;
    ST_CPY( path, argv[3] );
    strupr( path );
    if ( do_map )
    {
        ret = nw_map_fakeroot( drv, path );
        if ( ret )
            printf( "Error %02X mapping Fake ROOT for drive %c: to %s", ret, drv, path );
        else
            printf( "Fake ROOT for drive %c: mapped to %s", drv, path );
    }
    else
    {
        nw_del_drive_mapping( drv );
        printf( "Mapping for drive %c: deleted", drv );
    }
    printf( "\n\n" );
    exit( 0 );
}
#endif
