//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Verify Password of a Bindery Object

#include"gd_tools.h"
#include"gd_nw.h"
#include"nit.h"


typedef struct                                  // verify password of bindery object
{
        WORD16  buffer_length ;
        BYTE    function ;
        WORD16  obj_type ;
        BYTE    req_data[48+128+2] ;
}       vpo_req_t ;
typedef struct
{
        WORD16  buffer_length ;
}       vpo_rep_t ;


int     nw_verify_password_of_object( STRING oName, STRING oPass, WORD16 oType )
{
    vpo_req_t   req ;
    vpo_rep_t   rep ;
    BYTE        buf[48+128+3] ;
    int         ofset ;

    CLR_BLOCK(buf);
    st_trim( oName );   _strupr( oName );
    st_trim( oPass );   _strupr( oPass );

    //  setup the NetWare packets
    CLR_BLOCK(req);
    CLR_BLOCK(rep);
    NW_SET_BUFFER_SIZE(req);
    NW_SET_BUFFER_SIZE(rep);
    req.function= (BYTE) 0x3F ;
    req.obj_type= nw_word_hilo_to_lohi( oType );

//  buf looks like this if name=USER and password=PASS
//  4USER4PASS
//  0123456789

    ofset = strlen(oName)+1 ;
    strcpy( &buf[      1], oName );
    strcpy( &buf[ofset+1], oPass );
    buf[0]      = strlen(oName);
    buf[ofset]  = strlen(oPass);
    memmove( req.req_data, buf, sizeof(req.req_data) );

// printf( "buffer size = %d, %d, %d\n", req.buffer_length, (int) buf[0], (int) buf[ofset] );

    return( nw_call_w_buffers( NETWARE_BINDERY, &req, &rep ) );
}


#if 0
void    main( void )
{
    UCHAR       userName[49], userPass[129] ;
    UINT32      objID = UINT32MAX ;
    int         ret ;

    objID = nw_get_username( userName );
    printf( "Logged in as %s [Object ID=%08lX]\n\n", userName, objID );
    FOREVER
    {
        printf( "PW? " );
        gets( userPass );
        ret = nw_verify_password_of_object( userName, userPass, (WORD16) OT_USER );
        if ( ret )
            printf( "\tError %d [%02Xh] for [%s|%s]\n", ret, ret, userName, userPass );
        if ( ! strlen(userPass) )
            exit(0);
    }
}
#endif
