//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Push & Pop INT16 Variables

#include"gd_tools.h"


#pragma check_stack(off)


/*      globals to allow pushing and popping of variables
*/
#define I16_STACK_MAX   30
static  INT16           i16vs_idx_ = -1 ;
static  struct
{
        INT16           i16_var ;
}       i16_stack_      [I16_STACK_MAX];


INT16   push_i16( INT16 i )             /*  save variable on the stack  */
{
    if ( i16vs_idx_ < (I16_STACK_MAX-1) )
    {
        i16vs_idx_++ ;
        i16_stack_[i16vs_idx_].i16_var = i ;
        return( OK );
    }
    stack_err_msg( "push_i16", (FLAG) 1 );
    return( ERROR );
}


INT16   pop_i16( void )                 /*  remove variable from stack  */
{
    INT16       i ;

    if ( i16vs_idx_ >= 0 )
    {
        i = i16_stack_[i16vs_idx_].i16_var ;
        i16vs_idx_-- ;
        return( i );
    }
    stack_err_msg( "pop_i16", (FLAG) -1 );
    return( 0 );
}


#if 0
static  void dump_stack()
{
    INT16 i ;
    printf( "\nStack pointer %2d\n", i16vs_idx_ );
    LOOP( i, 0, (I16_STACK_MAX-1), 1 )
    {
        printf( "Stack index %2d,  data: %d\n", i, i16_stack_[i].i16_var );
    }
}
void    main()
{
    INT16 i ;
    gd_init( 0 );
    LOOP( i, 0, (I16_STACK_MAX-1), 1 )
    {
        push_i16( i * 2 );
    }
    dump_stack();
    push_i16( 777 );
    dump_stack();
    LOOP( i, 0, I16_STACK_MAX, 1 )
    {
        pop_i16();
    }
    dump_stack();
    gd_exit( 0, "" );
}
#endif
