//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Push & Pop INT32 Variables

#include"gd_tools.h"


#pragma check_stack(off)


//      globals to allow pushing and popping of variables

#define I32_STACK_MAX   20
static  INT16           i32vs_idx_ = -1 ;
static  struct
{
        INT32           i32_var ;
}       i32_stack_      [I32_STACK_MAX];


INT16   push_i32( INT32 i )             //  save variable on the stack
{
    if ( i32vs_idx_ < (I32_STACK_MAX-1) )
    {
        i32vs_idx_++ ;
        i32_stack_[i32vs_idx_].i32_var = i ;
        return( OK );
    }
    stack_err_msg( "push_i32", (FLAG) 1 );
    return( ERROR );
}


INT32   pop_i32( void )                 /*  remove variable from stack  */
{
    INT32       i ;

    if ( i32vs_idx_ >= 0 )
    {
        i = i32_stack_[i32vs_idx_].i32_var ;
        i32vs_idx_-- ;
        return( i );
    }
    stack_err_msg( "pop_i32", (FLAG) -1 );
    return( 0 );
}


#if 0
static  void dump_stack()
{
    INT16 i ;
    printf( "\nStack pointer %2d\n", i32vs_idx_ );
    LOOP( i, 0, (I32_STACK_MAX-1), 1 )
    {
        printf( "Stack index %2d,  data: %ld\n", i, i32_stack_[i].i32_var );
    }
}
void    main()
{
    INT16 i ;
    gd_init( 0 );
    LOOP( i, 0, (I32_STACK_MAX-1), 1 )
    {
        push_i32( (INT32) i * 2 );
    }
    dump_stack();
    push_i32( 777L );
    dump_stack();
    LOOP( i, 0, I32_STACK_MAX, 1 )
    {
        pop_i32();
    }
    dump_stack();
    gd_exit( 0, "" );
}
#endif
