//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Push & Pop String Variables

#include"gd_tools.h"


#pragma check_stack(off)


//      globals to allow pushing and popping of variables

#define STR_STACK_MAX   20
static  INT16           svs_idx_ = -1 ;
static  struct
{
        UCHAR           *st_var ;
}       str_stack_      [STR_STACK_MAX];


INT16   push_str( UCHAR *s )            /*  save string on the stack    */
{
    if ( svs_idx_ < (STR_STACK_MAX-1) )
    {
        svs_idx_++ ;
        str_stack_[svs_idx_].st_var = (UCHAR *) malloc( strlen(s) + 1 );
        if ( str_stack_[svs_idx_].st_var == NULPTR )
        {
            ut_err_msg( "push_str", "Not enough memory to push string", s );
            return( ERROR );
        }
        strcpy( str_stack_[svs_idx_].st_var, s );
        return( OK );
    }
    stack_err_msg( "push_str", (FLAG) 1 );
    return( ERROR );
}


UCHAR   *pop_str( UCHAR *s )            /*  remove string from the stack */
{
    UCHAR       *str = NULPTR ;

    if ( svs_idx_ >= 0 )
    {
        if ( str_stack_[svs_idx_].st_var != NULPTR )
        {
            if ( s != NULPTR )
                strcpy( s, str_stack_[svs_idx_].st_var );
            str = str_stack_[svs_idx_].st_var ;
            free( str_stack_[svs_idx_].st_var );
            str_stack_[svs_idx_].st_var = NULPTR ;
        }
        svs_idx_-- ;
        return( str );
    }
    stack_err_msg( "pop_str", (FLAG) -1 );
    return( NULPTR );
}


#if 0
#include "gd_extrn.h"
static  void dump_stack()
{
    INT16 i ;
    LOOP( i, 0, (STR_STACK_MAX-1), 1 )
    {
        printf( "Stack index %2d,  data: %s\n", i, str_stack_[i].st_var );
    }
}
void    main()
{
    INT16 i ;
    UCHAR str[81] ;
    gd_init( 0 );
    str[0] = EOS ;
    NewScreen();
    FOREVER
    {
        DspMessage( 1,3, vid.normal_fg, vid.normal_bg, "Stack pointer %2d", svs_idx_ );
        EnterText( str, 1, NO, 0, "1=Push, 2=Pop, 3=Dump, 4=quit" );
        switch ( str[0] )
        {
            case '1' :
                EnterText( str, 80, NO, 0, "Push" );
                push_str ( str );
                break ;
            case '2' :
                pop_str( str );
                DspMessage( 3,1, vid.normal_fg, vid.normal_bg, "popped: [%s] ", str );
                break ;
            case '3' :
                NewScreen();
                dump_stack();
                break ;
            case '4' :
                MoveCursor(25,1);
                gd_exit( 0, "" );
            default:
                NewScreen();
                sn_beep();
        }
    }
}
#endif
