//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Push & Pop UCHAR Variables

#include"gd_tools.h"


#pragma check_stack(off)


//      globals to allow pushing and popping of variables

#define UCH_STACK_MAX   30
static  INT16           cvs_idx_ = -1 ;
static  struct
{
        UCHAR           ch_var ;
}       uch_stack_      [UCH_STACK_MAX];


INT16   push_uchar( UCHAR c )           /*  save variable on the stack  */
{
    if ( cvs_idx_ < (UCH_STACK_MAX-1) )
    {
        cvs_idx_++ ;
        uch_stack_[cvs_idx_].ch_var = c ;
        return( OK );
    }
    stack_err_msg( "push_uchar", (FLAG) 1 );
    return( ERROR );
}


UCHAR   pop_uchar( void )               /*  remove variable from stack  */
{
    UCHAR       c ;

    if ( cvs_idx_ >= 0 )
    {
        c = uch_stack_[cvs_idx_].ch_var ;
        cvs_idx_-- ;
        return( c );
    }
    stack_err_msg( "pop_uchar", (FLAG) -1 );
    return( 0 );
}


#if 0
static  void dump_stack()
{
    INT16 i ;
    printf( "\nStack pointer %2d\n", cvs_idx_ );
    LOOP( i, 0, (UCH_STACK_MAX-1), 1 )
    {
        printf( "Stack index %2d,  data: %c\n", i, uch_stack_[i].ch_var );
    }
}
void    main()
{
    INT16 i ;
    gd_init( 0 );
    LOOP( i, 0, (UCH_STACK_MAX-1), 1 )
    {
        push_uchar( (UCHAR) i + 'A' );
    }
    dump_stack();
    push_uchar( '*' );
    dump_stack();
    LOOP( i, 0, UCH_STACK_MAX, 1 )
    {
        pop_uchar();
    }
    dump_stack();
    gd_exit( 0, "" );
}
#endif
