//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Low-level Sound Functions ... NOT PORTABLE!

#include "gd_tools.h"
#include "gd_extrn.h"


void    ToneInit( void )                        //  Initialize the speaker timer
{
    //  Define control bit field parameters for the timer chip
    int sc      = 2 ;                           //  use counter 2
    int rl      = 3 ;                           //  mode to load period
    int mode    = 3 ;                           //  square wave generator
    int bcd     = 0 ;                           //  use binary
    int control_word ;

    if ( _sound_sys )
    {
        control_word = sc*0x40 + rl*0x10 + mode*2 + bcd;
        _outp( 0x43, control_word );
    }
}


void    ToneSet( int sq_freq )                  //  Set the Tone on the Speaker
{
    UCHAR       halfword ;                      //  output char at a time

    if ( _sound_sys )
    {
        halfword = (UCHAR) LOBYTE(sq_freq);
        _outp( 0x42, halfword );
        halfword = (UCHAR) HIBYTE(sq_freq);
        _outp( 0x42, halfword );
    }
}


void    ToneOn( void )                          //  Turn the Tone ON
{
    UCHAR       halfword ;                      //  byte operations only

    if ( _sound_sys )
    {
        halfword = (UCHAR) (_inp( 0x61 ) | 3);  //  turn speaker & timer on
        _outp( 0x61, halfword );
    }
}


void    ToneOff( void )                         //  Turn the Tone OFF
{
    UCHAR       halfword ;                      //  byte operations only

    if ( _sound_sys )
    {
        halfword = (UCHAR) (_inp( 0x61 ) & 0xFC); // turn speaker & timer off
        _outp( 0x61, halfword );
    }
}


int     ToneFreq( int frequency )               //  Calculate a frequency for ToneSet()
{
    long    hertz = 1193182L ;                  //  conversion factor
    long    l;

    l       = hertz / frequency;
    return( (int) l );
}


void    Tone( int frequency, int duration )     //  Make a tone
{
    if ( _sound_sys )
    {
        ToneSet( ToneFreq( frequency ) );
        ToneOn();
        tm_sleep_msecs( duration );
        ToneOff();
    }
}
