//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Copy a String to Another String

#include"gd_tools.h"
#pragma check_stack(off)


STRING  st_cpy( UCHAR dest[], UCHAR src[], INT16 maxchar )
/*
        Copy a string from "src" to "dest".  At the most, "maxchar-1"
        characters will be copied, in order to accomodate the terminating
        EOS. "dest" must have been declared/allocated "maxchar" characters
        long.
*/
{
    register    int     n ;
    register    UCHAR   *d ;
    INT16       l ;

    d = dest ;
    l = maxchar - 1 ;
    n = strlen( src );
    if ( n > l )
        n = l ;
    memmove( d, src, n );
    dest[n] = EOS ;
    return( d );                                // destination string
}


#if 0
/*              st_cpy Timed Test ... 1131 tics - no register vars
                st_cpy Timed Test ... 1004 tics - register loop counter
                st_cpy Timed Test ...  681 tics - register ctr & ptrs
                st_cpy Timed Test ...  681 tics - register ctr & dest ptr
                st_cpy Timed Test ...  200 tics - memmove
*/
void main()
{
    UCHAR       str[81], *s = "1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!@#$%^&*()_+=-{}" ;
    INT16       i, hh, mm, ss, tt ;
    INT32       hmst1, hmst2, tics1, tics2 ;
    printf( "\n\ast_cpy Timed Test ..." );
    tm_getsystemtime( &hmst1, &tics1, &hh, &mm, &ss, &tt );
    LOOP( i, 1, 5000, 1 )
    {  st_cpy( str, s, 81 );  }
    tm_getsystemtime( &hmst2, &tics2, &hh, &mm, &ss, &tt );
    printf( " %ld - %ld (%ld tics)\n", hmst1, hmst2, (tics2-tics1) );
    st_cpy( str, s, 11 );  printf( "[%s]\n", str );
    st_cpy( str, s, 81 );  printf( "[%s]\n", str );
}
#endif
