//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Extract Leftmost Characters from a String

#include"gd_tools.h"


#pragma check_stack(off)


STRING  st_left( UCHAR *dest, UCHAR *src, INT16 cnt, INT16 maxdest )
/*
  Synopsis      str = st_left(dest,src,cnt,maxdest)
                UCHAR *str      Pointer to returned string
                UCHAR *dest     Pointer to destination string
                UCHAR *src      Pointer to source string
                INT16 cnt       Number of characters to extract
                INT16 maxdest   Maximum size of destination

  Description
                This function extracts the cnt left most characters from src
                and returns the characters in dest.  The number of characters
                extracted is no greater than the length of the source string,
                or the maximum size of the destination string minus 1 (to
                account for the trailing EOS).  The actual number of characters
                extracted is returned as the function value.

  Returns       dest            The string of extracted characters
                str             Pointer to the string of extracted characters
*/
{
    INT16       n ;

    n = (cnt > maxdest-1) ? maxdest : cnt+1 ;   //  # of chars to move
    return( st_cpy(dest, src, n) );             //  destination string
}


#if 0
void main()
{
    UCHAR       work[11], str[11] ;

    strcpy( work, "1234567890" );
    st_left( str, work, 50, 11 );
    printf( "st_left(str,work,50,11); <--- [%s]\n", str );
    st_left( str, work,  5, 11 );
    printf( "st_left(str,work, 5,11); <--- [%s]\n", str );
    printf( "st_left(str,work, 5,11); <--- [%s]\n", st_left(str, work, 5, 11) );
}
#endif
