//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Extract the n rightmost characters from a string

#include"gd_tools.h"
#pragma check_stack(off)


INT16   StrR( STRING str_to, STRING str_from, INT16 howmany )
/*
 Synopsis       len = StrR( str_to, str_from, howmany );
                INT16 len       Length of output string
                UCHAR *str_to   Pointer to target string
                UCHAR *str_from Pointer to source string
                INT16 howmany   Number of characters to transfer

 Description    StrR extracts the "howmany" right most characters of str_from
                and moves them to string str_to.  If str_from contains less than
                "howmany" charcters (or ""), then str_from is copied.  The
                number of characters transferred is returned.

 Returns        len             The number of characters moved.
                str_to          The string with extracted characters.
*/
{
    howmany += 1 ;                              //  need 1 more for EOS
    if ( howmany < 1 )
        howmany = 1 ;                           //  avoid negatives
    if ( ((INT16) strlen(str_from) + 1) > howmany )
    {
        while ( ((INT16) strlen(str_from) + 1) > howmany )
        {
            str_from++ ;
        }
    }
    st_cpy( str_to, str_from, howmany );
    return( strlen(str_to) );
}

#if 0
main()
{
    UCHAR       *fmt, *from, to[81] ;
    INT16       tomove, moved ;

    fmt = "\n to=%-6s  from=%-6s  tomove=%2d  moved=%2d" ;
    from = "Cats"; tomove = 3; moved = StrR( to, from, tomove ); printf( fmt, to, from, tomove, moved );
    from = "Cats"; tomove = 4; moved = StrR( to, from, tomove ); printf( fmt, to, from, tomove, moved );
    from = "Cats"; tomove = 5; moved = StrR( to, from, tomove ); printf( fmt, to, from, tomove, moved );
    from = ""    ; tomove = 3; moved = StrR( to, from, tomove ); printf( fmt, to, from, tomove, moved );

//  Produces:   to=ats     from=Cats    tomove= 3  moved= 3
//              to=Cats    from=Cats    tomove= 4  moved= 4
//              to=Cats    from=Cats    tomove= 5  moved= 4
//              to=        from=        tomove= 3  moved= 0
}
#endif
