//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Decode a Serial Number

#include"gd_tools.h"


/*
        Layout for serial number:

                VVvvNNNNNc
                | | \_|_/|__ check digit
                | |   |_____ actual serial number, may overflow into minor version
                | |_________ minor version
                |___________ major version
*/


INT16   decode_serial( STRING ser_str, STRING decoded_ser )
{
    UCHAR       new_ser[14], sub_ser[11] ;
    INT16       i, chk, old_chk ;
    INT32       ser ;

    new_ser[ 0 ] = *ser_str++ ;
    new_ser[ 3 ] = *ser_str++ ;
    new_ser[ 2 ] = *ser_str++ ;
    new_ser[ 4 ] = *ser_str++ ;
    new_ser[ 6 ] = *ser_str++ ;
    new_ser[ 5 ] = *ser_str++ ;
    old_chk      = *ser_str++ ;
    new_ser[ 1 ] = *ser_str++ ;
    new_ser[ 8 ] = *ser_str++ ;
    new_ser[ 7 ] = *ser_str++ ;
    LOOP( i, 0, 8, 1 )
    {
        new_ser[i] = new_ser[i] + (UCHAR) '0' ;
    }
    new_ser[ 9 ] = EOS ;
    st_cpy( decoded_ser, new_ser, 11 );
    SubStr( sub_ser, new_ser, 4, 5 );
    ser = Str2Long( sub_ser );                  //  get actual serial #
    if ( (strlen(sub_ser) != 5) || (ser < 1L) ) //  must be 5 dig. and > 0L
        return( ERROR );
    ser = Str2Long( new_ser );
    chk = CheckDigit_10( ser, 9 );
    if ( chk == old_chk )
        return( OK );
    else
        return( ERROR );
}
