//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Return the DOS command line


#include"gd_tools.h"
#include<memory.h>


#define         CMD_LOC_LEN     0x0080
#define         CMD_LOC_START   0x0081


INT16   CmdLine( UCHAR *cmd_line )
/*
  Function      Return the entire DOS command line, including leading and trailing spaces.

  Synopsis      ln = CmdLine( cmd_line );
                INT16 ln        Length of the command line
                UCHAR *cmd_line Command line

  Description   This function returns the command line typed at the DOS level when the program was
                invoked.  The entire command line (minus the program name) is returned, including
                all white space.  The length of the command line is returned as the value of the
                function.  Space for the command line must be allocated by the calling function:
                expect 127, so reserve 128 chars.

  Returns       ln              Length of the command line
                cmd_line        Pointer to the command line string
*/
{
    ADS         to_ads ;
    INT16       ln ;

    AbsPointer( (UCHAR *) &ln, &to_ads );
    _movedata( _psp, CMD_LOC_LEN, to_ads.s, to_ads.r, 1 );
    ln &= 0x00ff ;                              //  single byte
    AbsPointer( cmd_line, &to_ads );
    _movedata( _psp, CMD_LOC_START, to_ads.s, to_ads.r, ln );
    *(cmd_line+ln) = EOS ;                      //  terminate string
    return( ln );
}


#if 0
void main()
{
    UCHAR cmd[128] ;
    INT16 length ;
    length = CmdLine( cmd );
    printf( "\n\nCommand line entered was %d bytes:\n[%s]\n\n", length, cmd );
}
#endif
