//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Get Color Code


#include"gd_tools.h"


int     ut_color_code( const char sColor[] )
{
    int         colcode = -1 ;
    char        pcBuf2[3], pcBuf3[4], *color ;

    color = strdup( sColor );
    strlwr( color );
    switch ( color[0] )
    {
        case 'c' :                              // Cyan
            colcode = 3 ;
            break ;
        case 'm' :                              // Magenta
            colcode = 5 ;
            break ;
        case 'r' :                              // Red
            colcode = 4 ;
            break ;
        case 'w' :                              // White
            colcode = 7 ;
            break ;
        case 'y' :                              // Yellow
            colcode = 14 ;
            break ;
        case 'b' :
            switch ( color[1] )
            {
                case 'l' :
                    if ( color[2] == 'a' )      // BLAck
                        colcode = 0 ;
                    if ( color[2] == 'u' )      // BLUe
                        colcode = 1 ;
                    goto pc_done ;
                case 'r' :
                    if ( color[2] == 'o' )      // BROwn
                        colcode = 6 ;
                    if ( color[2] == 'w' )      // BRWhite
                        colcode = 15 ;
                    goto pc_done ;
                case 'w' :                      // BWhite
                    colcode = 15 ;
                default :                       // ?
                    goto pc_done ;
            }
            break ;
        case 'g' :
            if ( color[1] == 'r' && color[2] == 'a' )  // GRAy
                colcode = 8 ;
            if ( color[1] == 'r' && color[2] == 'e' && color[3] == 'y' )  // GREY
                colcode = 8 ;
            if ( color[1] == 'r' && color[2] == 'e' && color[3] == 'e' )  // GREEn
                colcode = 2 ;
            break ;
    }

    if ( colcode > -1 )                         // already identified
        goto pc_done ;

    ST_CPY( pcBuf2, color );                    // 2 chars
    ST_CPY( pcBuf3, color );                    // 3 chars
    if ( st_eq(pcBuf2, "lb") || st_eq(pcBuf3, "ltb") )  // light blue
    {
        colcode = 9 ;
        goto pc_done ;
    }
    if ( st_eq(pcBuf2, "lc") || st_eq(pcBuf3, "ltc") )  // light cyan
    {
        colcode = 11 ;
        goto pc_done ;
    }
    if ( st_eq(pcBuf2, "lg") || st_eq(pcBuf3, "ltg") )  // light green
    {
        colcode = 10 ;
        goto pc_done ;
    }
    if ( st_eq(pcBuf2, "lm") || st_eq(pcBuf3, "ltm") )  // light magenta
    {
        colcode = 13 ;
        goto pc_done ;
    }
    if ( st_eq(pcBuf2, "lr") || st_eq(pcBuf3, "ltr") )  // light red
    {
        colcode = 12 ;
        goto pc_done ;
    }
    if ( st_eq(pcBuf2, "lw") || st_eq(pcBuf3, "ltw") )  // bright white
    {
        colcode = 15 ;
        goto pc_done ;
    }

pc_done:
    free( color );
    return( colcode );
}


#if 0
void    main( int argc, char *argv[] )
{
    char *color[] = { "BLACK", "BLUE", "GREEN", "CYAN", "RED", "MAGENTA",
                      "BROWN", "WHITE", "GREY", "LT_BLUE", "LT_GREEN",
                      "LT_CYAN", "LT_RED", "LT_MAGENTA", "YELLOW", "BR_WHITE" };
    int  c ;

    c = ut_color_code( argv[1] );
    if ( c == ERROR )
        printf( "%s -> ERROR\n", argv[1] );
    else
        printf( "%s -> %d = %s\n", argv[1], c, color[c] );
}
#endif
