//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

#include "gd_tools.h"


UINT32  AbsFnPointer( INT16 (*ptr)(), ADS *pads )
{
#if LPROG
    pads->s = FP_SEG( ptr );
    pads->r = FP_OFF( ptr );
#else                                   //  Small Code model
    WORD16  cs, ss, ds, es;
    ReadSegReg( &cs, &ss, &ds, &es );
    pads->s = ( WORD16 ) cs;
    pads->r = ( WORD16 ) ptr;
#endif
    return( (UINT32) ( 0x0fffffL & ((((UINT32) pads->s) << 4) + (UINT32) pads->r) ) );
}


/*
#ifdef  C_DOC
//fn    AbsPointer
//n     Return the Physical Address of a Function
//kw    function pointer~ absolute address~ address pointer~ pointer~
        large data model~ small data model~ memory model~ LPROG
//sum
#include "gd_tools.h"
absval = AbsFnPointer( ptr, pads );
UINT32 absval   The 20-bit physical address of the specified function.
void (*ptr)()   Pointer to the function whose address is to be computed.
ADS  *pads      An ADS structure containing the offset and segment components of the physical address of the function.
//des
This function returns the physical address of the function pointed to by ptr. `
The result is computed in two forms:
(1) as a 20-bit integer returned as an unsigned long (UINT32);
(2) as the split segment and offset in an ADS structure.

Caveat: Make sure LPROG is set properly in <gd_tools.h>.
//rval
absval  The 20-bit physical address of the specified function.
*pads   The offset and segment components of the physical address of the function.
//see   AbsPointer
//sam
void main( void )
{
    ADS     address;
    UINT32  AbsFnPointer();
    UINT32  ptr20;

    printf( "\n\n Find Absolute Address of a Function: \n\n" );
    ptr20 = AbsFnPointer( AbsFnPointer, &address );
    printf( " 20-bit address = %05lX \n segment:offset = %04x:%04x \n",
            ptr20, address.s, address.r );
}
#endif  // C_DOC
*/
