//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Is Bit "n" set in 16-bit Word?
//      Macro version: ISBITSET


#include"gd_tools.h"

#pragma check_stack(off)


INT16   IsBitSet( INT16 n, INT16 wrd )
/*
  Synopsis      ret = IsBitSet( n, wrd );
                INT16 ret       return code
                INT16 n         bit number
                INT16 wrd       word to be examined

  Description   This function reports whether bit n in wrd is ON or NOT.

  Returns       TRUE or FALSE
*/
{
    return( (wrd >> n) & ~(~0 << 1) );
}


INT16   GetBits( UINT16 wrd, UINT16 pos, UINT16 num )
/*
  Synopsis      ret = GetBits( wrd, pos, num );
                INT16 ret       return code
                UINT16 wrd      word to be examined
                UINT16 pos      posistion to start
                UINT16 num      number of bits to extract

  Description   Get the "num" bits starting at "pos" from "wrd"

  Returns       Extracted value
*/
{
    return( (wrd >> (pos+1-num)) & ~(~0 << num) );
}


#if 0
void main()
{
    INT16   num, i ;
    printf( "\n Number: " );
    scanf( "%d", &num );
    printf( "\n Number: %d is in binary --> ", num );
    for ( i=15 ; i > -1 ; i-- )
    {   if ( IsBitSet( i, num ) )  printf( "1" );  else    printf( "0" );  }
    printf( "\n" );
}
#endif
