//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>


#include"gd_tools.h"


UINT32  AbsPointer( UCHAR *ptr, ADS *pads )
{
//  Make sure LDATA is set properly in gd_tools.h
#if LDATA
    pads->s = FP_SEG( ptr );
    pads->r = FP_OFF( ptr );
#else
    WORD16  cs, ss, ds, es;             //  not reqd for LDATA
    ReadSegReg( &cs, &ss, &ds, &es );
    pads->s = ds ;
    pads->r = (WORD16) ptr ;
#endif                                  // LDATA
    return( (UINT32) ((unsigned FAR *) ptr) );
}


#ifdef  C_DOC
//fn    AbsPointer
//n     Return the Absolute Value of a Data Pointer
//kw    data pointer~ absolute address~ address pointer~ pointer~
        large data model~ small data model~ memory model~ LDATA
//summ
#include "gd_tools.h"

absval = AbsPointer(ptr, pads);
UINT32 absvalThe absolute address represented by the specified pointer, ptr.
UCHAR *ptrThe pointer whose absolute address is computed.
ADS *padsAn ADS structure containing the offset and segment of the absolute address pointed to by pointer.
//desc
This function returns the absolute address of the address pointed to by`
pointer.  The result is returned as an unsigned long integer (UINT32).  For`
large data models, pointers are 32-bit quantities representing both segment and`
offset, but for small data models, pointers are offsets within the default data`
segment.  A segment offset address of the pointer is returned in the ADS`
structure.
//rval
absval  The absolute address of *ptr.
*pads   An ADS variable representing the location of *ptr.
//see   AbsFnPointer
//sam
void main( void )
{
    ADS    a ;
    UINT32 ptr20 ;

    ptr20 = AbsPointer( (UCHAR *) ptr20, &a );
    printf( "\n\nFind Absolute Address of data item"
            "\n\nUINT32 address = %05lX\nsegment:offset = %04X:%04X\n",
            ptr20, a.s, a.r );
}
#endif  // C_DOC
