//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Push & Pop Drive & Path


#include"gd_tools.h"
#include<direct.h>


//      globals to allow pushing and popping drive & path

#define PATH_STACK_MAX  20
static  INT16   ps_idx_ = -1 ;
static  struct
{
    UCHAR *directory ;
}   path_stack_[PATH_STACK_MAX];


#pragma check_stack(off)


INT16   PushPath( void )        //  save current drive & path position on stack
{
    UCHAR       cdir[FS_LEN] ;

    if ( _getcwd( cdir, FS_LEN ) == NULL )
        return( ERROR );
    if ( ps_idx_ < (PATH_STACK_MAX-1) )
    {
        ps_idx_++ ;
        path_stack_[ps_idx_].directory = _strdup( cdir );
        if ( path_stack_[ps_idx_].directory == NULL )
        {
            ps_idx_-- ;
            return( ERROR );
        }
        return( OK );
    }
    return( ERROR );            //  no room!
}


INT16   PopPath( void )         //  restore most recent drive & path from stack
{
    UCHAR       drive ;

    if ( ps_idx_ NOT_LESS 0 )
    {
        drive = *(path_stack_[ps_idx_].directory) ;
        if ( SetDrive( drive ) == ERROR )
            return( ERROR );
        if ( _chdir( path_stack_[ps_idx_].directory ) == -1 )
            return( ERROR );
        free( path_stack_[ps_idx_].directory );
        ps_idx_-- ;
        return( OK );
    }
    return( ERROR );
}

#if 0
static  void push_it()
{
    if ( PushPath() == ERROR )  printf( "Path stack overflow: " );
    printf( "Stack pointer = %2d\n", ps_idx_ );
}
static  void pop_it()
{
    if ( PopPath() == ERROR )   printf( "Path stack underflow: " );
    printf( "Stack pointer = %2d\n", ps_idx_ );
}
void main(void)
{
    int i ;

    printf( "\nTest Path Push/Pop\n\n" );
    LOOP( i, 1, (PATH_STACK_MAX+2), 1 )
    {   push_it(); }
    LOOP( i, 1, (PATH_STACK_MAX+2), 1 )
    {   pop_it();  }
    LOOP( i, 0, (PATH_STACK_MAX-1), 1 )
    {
        printf( "Stack pointer = %2d  path = %s\n", i, path_stack_[i].directory );
    }
}
#endif
