//<c>   Copyright 1980-1999 by Gerry J. Danen; all rights reserved.

//<t>   Random Numbers


#include"gd_tools.h"


INT16   RandomNumber( INT16 lower, INT16 upper )

//      Return a random number between lower and upper,
//      including lower and upper.
{
    INT16       diff ;

    diff    = upper - lower + 1 ;
    if ( diff < 0 )
        diff = -diff ;
    if ( diff == 0 )
        return( lower );
    return( ( (rand()) MOD diff) + lower );
}


ULONG   random_ULONG( ULONG lower, ULONG upper )
//      Return a random number between lower and upper,
//      including lower and upper, ranging from 0 to 999999999.
{
    ULONG       diff, result ;

    diff = upper - lower + 1 ;
    result = ((ULONG) rand()) * 1000 ;          // call rand() 3x to create a 9-digit number
    result = result + (ULONG) (rand() MOD 1000);
    result = result * 1000 ;
    result = result + (ULONG) (rand() MOD 1000);
    result = (result MOD diff) + lower;
    return( result );
}


void    RandomSeed( void )                      // [re]seed the random number generator
{
    R_REGS ;
    UINT32      rn ;

    _AH = GET_TIME ;                            // get system time
    INTDOS(r);
    rn = (_CL*17 + _DH*_DL) MOD 32767 ;
    srand( (UINT16) rn );                       // use part of it for random seed
}
